////////////////////////////////////////////////////////
// Copyright (c) M.Iakobovski 11.06.2007 Version v.02 //
// Generation pseudorandom numbers sequence           //
// with direct access                                 //
////////////////////////////////////////////////////////

#include "stdio.h"
#include "stdlib.h"
#include "memory.h"
#include "prand.h"
#include "lrnd32.h"

void lrnd32init(void);

 int nbits=255; //127; // 255; // 1023; 511; 255;//7 11 23 31 89 127 521 607 1279// 10 31 33 ??? 19937
 int bits_of_result=32;//32;//32;//8*sizeof(unsigned long);

// unsigned __int64 i_64;

#define bprintf_lrnd32set 0
#define shift_lrnd32set  0x0af3ef34

static char b_inited_32;
static PRAND r1_32;
static BINT bi_32;

unsigned long lrnd32(void)
{
 if(!b_inited_32)
	 lrnd32set(0,0);

 return prand(&r1_32);
}

void lrnd32init(void)
{
	if(b_inited_32)
		return;

	bint_init_BINT_UL(&bi_32, BINT_BITS, shift_lrnd32set);
	prand_init(&r1_32,nbits,bits_of_result);

	b_inited_32=1;
}

void lrnd32set(unsigned long c1, unsigned long c0)
{
#define mlt 0x10000

 if(!b_inited_32)
	 lrnd32init();

 bint_set_BINT_UL(&bi_32, c1);
 bint_mult_BINT_UL(&bi_32, mlt);
 bint_mult_BINT_UL(&bi_32, mlt);

 bint_add_BINT_UL(&bi_32, c0);
 bint_add_BINT_UL(&bi_32, shift_lrnd32set);

 prand_set_c(&r1_32, &bi_32); // c     bi
}

unsigned long lrnd32direct(unsigned long c1, unsigned long c0)
{
	lrnd32set(c1,c0);
	return lrnd32();
}

