////////////////////////////////////////////////////////
// Copyright (c) M.Iakobovski 11.06.2007 Version v.02 //
// Generation pseudorandom numbers sequence           //
// with direct access                                 //
////////////////////////////////////////////////////////

#include "bint.h"

#define CVECT_MAX_N 100
#define PRAND_MAX_N 11

typedef 
	struct
	{
	int offset;
	int n;
	char *r;
	}
	RPOLE;

typedef RPOLE *VECT;

typedef 
	struct
	{
	RPOLE r; //   
	
	char bcompressed; //    
	int nbase; //    
	int base[PRAND_MAX_N]; //     
	int bits_of_result; //  
	}
	PRAND; //   

typedef PRAND *LPPRAND;

typedef 
	struct
	{
	int n; //   
	int m; //   
	int a[CVECT_MAX_N]; //    
	}
	CVECT; //  

typedef CVECT *LPCVECT;


void prand_init(LPPRAND pr, int k, int bits_of_result); //    
unsigned long prand_set(LPPRAND pr, BINT i); // c     i
unsigned long prand_set_c(LPPRAND pr, LPBINT pbi0); // c     bi
unsigned long prand(LPPRAND pr); //      
//unsigned long prandul(LPPRAND pr); //      


//-------------------------------------------

unsigned int devide_vect(VECT a, VECT b, VECT c, VECT r); // a=bc+r 
unsigned int devide_vect_compress(VECT a, int *dvd, int stb); // a = a mod dvd 

unsigned int calc_vect(VECT b);
void cp_vect(VECT b, VECT c); // b=c
void out_vecti(VECT a);
void put_vect(VECT b);
void qvadr_vect(VECT a, VECT p, VECT r); // r = a mod p
void qvadr_vect_compress(VECT a, int *dvd, int spb, VECT r); // r = (a*a) mod p

//-----------------------------------------

int cmp_vect(VECT x1, VECT x2);
void mult_vect(VECT a1, VECT a2, VECT p, VECT r);// r = (a1*a2) mod p

void out_pol(int *a, int  n);

